'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _Node2 = require('../Node.js');

var _Node3 = _interopRequireDefault(_Node2);

var _CompileError = require('../../utils/CompileError.js');

var _CompileError2 = _interopRequireDefault(_CompileError);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var JSXOpeningElement = function (_Node) {
	_inherits(JSXOpeningElement, _Node);

	function JSXOpeningElement() {
		_classCallCheck(this, JSXOpeningElement);

		return _possibleConstructorReturn(this, (JSXOpeningElement.__proto__ || Object.getPrototypeOf(JSXOpeningElement)).apply(this, arguments));
	}

	_createClass(JSXOpeningElement, [{
		key: 'transpile',
		value: function transpile(code, transforms) {
			_get(JSXOpeningElement.prototype.__proto__ || Object.getPrototypeOf(JSXOpeningElement.prototype), 'transpile', this).call(this, code, transforms);

			code.overwrite(this.start, this.name.start, this.program.jsx + '( ');

			var html = this.name.type === 'JSXIdentifier' && this.name.name[0] === this.name.name[0].toLowerCase();
			if (html) code.prependRight(this.name.start, '\'');

			var len = this.attributes.length;
			var c = this.name.end;

			if (len) {
				var i = void 0;

				var hasSpread = false;
				for (i = 0; i < len; i += 1) {
					if (this.attributes[i].type === 'JSXSpreadAttribute') {
						hasSpread = true;
						break;
					}
				}

				c = this.attributes[0].end;

				for (i = 0; i < len; i += 1) {
					var attr = this.attributes[i];

					if (i > 0) {
						if (attr.start === c) code.prependRight(c, ', ');else code.overwrite(c, attr.start, ', ');
					}

					if (hasSpread && attr.type !== 'JSXSpreadAttribute') {
						var lastAttr = this.attributes[i - 1];
						var nextAttr = this.attributes[i + 1];

						if (!lastAttr || lastAttr.type === 'JSXSpreadAttribute') {
							code.prependRight(attr.start, '{ ');
						}

						if (!nextAttr || nextAttr.type === 'JSXSpreadAttribute') {
							code.appendLeft(attr.end, ' }');
						}
					}

					c = attr.end;
				}

				var after = void 0;
				var before = void 0;
				if (hasSpread) {
					if (len === 1) {
						before = html ? '\',' : ',';
					} else {
						if (!this.program.options.objectAssign) {
							throw new _CompileError2.default("Mixed JSX attributes ending in spread requires specified objectAssign option with 'Object.assign' or polyfill helper.", this);
						}
						before = html ? '\', ' + this.program.options.objectAssign + '({},' : ', ' + this.program.options.objectAssign + '({},';
						after = ')';
					}
				} else {
					before = html ? '\', {' : ', {';
					after = ' }';
				}

				code.prependRight(this.name.end, before);

				if (after) {
					code.appendLeft(this.attributes[len - 1].end, after);
				}
			} else {
				code.appendLeft(this.name.end, html ? '\', null' : ', null');
				c = this.name.end;
			}

			if (this.selfClosing) {
				code.overwrite(c, this.end, this.attributes.length ? ')' : ' )');
			} else {
				code.remove(c, this.end);
			}
		}
	}]);

	return JSXOpeningElement;
}(_Node3.default);

exports.default = JSXOpeningElement;