'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _Node2 = require('../Node.js');

var _Node3 = _interopRequireDefault(_Node2);

var _CompileError = require('../../utils/CompileError.js');

var _CompileError2 = _interopRequireDefault(_CompileError);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var TaggedTemplateExpression = function (_Node) {
	_inherits(TaggedTemplateExpression, _Node);

	function TaggedTemplateExpression() {
		_classCallCheck(this, TaggedTemplateExpression);

		return _possibleConstructorReturn(this, (TaggedTemplateExpression.__proto__ || Object.getPrototypeOf(TaggedTemplateExpression)).apply(this, arguments));
	}

	_createClass(TaggedTemplateExpression, [{
		key: 'initialise',
		value: function initialise(transforms) {
			if (transforms.templateString && !transforms.dangerousTaggedTemplateString) {
				throw new _CompileError2.default("Tagged template strings are not supported. Use `transforms: { templateString: false }` to skip transformation and disable this error, or `transforms: { dangerousTaggedTemplateString: true }` if you know what you're doing", this);
			}

			_get(TaggedTemplateExpression.prototype.__proto__ || Object.getPrototypeOf(TaggedTemplateExpression.prototype), 'initialise', this).call(this, transforms);
		}
	}, {
		key: 'transpile',
		value: function transpile(code, transforms) {
			if (transforms.templateString && transforms.dangerousTaggedTemplateString) {
				var ordered = this.quasi.expressions.concat(this.quasi.quasis).sort(function (a, b) {
					return a.start - b.start;
				});

				var program = this.program;
				var rootScope = program.body.scope;

				// insert strings at start
				var templateStrings = this.quasi.quasis.map(function (quasi) {
					return JSON.stringify(quasi.value.cooked);
				}).join(', ');

				var templateObject = this.program.templateLiteralQuasis[templateStrings];
				if (!templateObject) {
					templateObject = rootScope.createIdentifier('templateObject');
					code.prependRight(this.program.prependAt, 'var ' + templateObject + ' = Object.freeze([' + templateStrings + ']);\n');

					this.program.templateLiteralQuasis[templateStrings] = templateObject;
				}

				code.overwrite(this.tag.end, ordered[0].start, '(' + templateObject);

				var lastIndex = ordered[0].start;
				ordered.forEach(function (node) {
					if (node.type === 'TemplateElement') {
						code.remove(lastIndex, node.end);
					} else {
						code.overwrite(lastIndex, node.start, ', ');
					}

					lastIndex = node.end;
				});

				code.overwrite(lastIndex, this.end, ')');
			}

			_get(TaggedTemplateExpression.prototype.__proto__ || Object.getPrototypeOf(TaggedTemplateExpression.prototype), 'transpile', this).call(this, code, transforms);
		}
	}]);

	return TaggedTemplateExpression;
}(_Node3.default);

exports.default = TaggedTemplateExpression;