'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.default = getSnippet;
function pad(num, len) {
	var result = String(num);
	return result + repeat(' ', len - result.length);
}

function repeat(str, times) {
	var result = '';
	while (times--) {
		result += str;
	}return result;
}

function getSnippet(source, loc) {
	var length = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 1;

	var first = Math.max(loc.line - 5, 0);
	var last = loc.line;

	var numDigits = String(last).length;

	var lines = source.split('\n').slice(first, last);

	var lastLine = lines[lines.length - 1];
	var offset = lastLine.slice(0, loc.column).replace(/\t/g, '  ').length;

	var snippet = lines.map(function (line, i) {
		return pad(i + first + 1, numDigits) + ' : ' + line.replace(/\t/g, '  ');
	}).join('\n');

	snippet += '\n' + repeat(' ', numDigits + 3 + offset) + repeat('^', length);

	return snippet;
}